/******************************************************
*                                LCD Library                                                          *
*        Supported hardware:                2x16 LCD                      *
*                          *
******************************************************/
#include "lcd.h"
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        LCD Initialization
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

void LCD_init(void)
{
        LCD_command(0X38);
        LCD_command(0X0C);
        LCD_command(0X01);
        LCD_command(0X06);
        
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
**** Cheacking the busy flag of LCD
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

void busy()
{
        flag=1;
        rs=0;
        rw=1;
        while(flag!=0)
        {
                en=0;
                en=1;
        }
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        Writing command to LCD 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

void LCD_command(bit_8 val)
{
        busy();
        LCD_PORT=val;
        rs=0;
        rw=0;
        en=1;
        en=0;
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        Writing string to LCD
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

void  LCD_sendstring(bit_8 *string)
{
        busy();
        while(*string)
                LCD_senddata(*string++);
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        Writing data to LCD
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

void LCD_senddata(bit_8 ch)
{
        busy();
        LCD_PORT = ch;
        rs=1;
        rw=0;
        en=1;
        en=0;
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        Writing 8-bit Value to LCD
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

void LCD_sendnum(bit_8 x)
{
        bit_8 temp;
        temp = x/0x10;
        if(temp>9)
                return;
        else
                LCD_senddata(temp+0x30);
        temp = x%0x10;
        if(temp>9)
                return;
        else
                LCD_senddata(temp+0x30);
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        Bringing Cursor to (X,Y) location of LCD
                X -> 1,2
                Y -> 1,16
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

void LCD_cursorxy(bit_8 x, bit_8 y)
{
        if((x<1||x>2)&&(y<1||y>16))
        {
                x=1;
                y=1;
        }
        if(x == 1)
                LCD_command(0x7F+y);
        else
                LCD_command(0xBF+y);
}

/* Added by Rajsekhar Nag Nag*/

void MSDelay(unsigned int itime)
{

unsigned int i, j;
for(i=0;i<itime;i++)
for(j=0;j<1275;j++);
}

void hex2lcd(unsigned char hex){
        char temp1,temp2;
        temp1 = hex;
        temp2=0;
        do{
                temp1 = temp1-100;
                if(temp1>=0)
                        temp2++;
        } while(temp1>=0);
        if(temp2>0)
        LCD_senddata(temp2+0x30);
        temp2=0;
        temp1 = temp1+100;
        do{
                temp1 = temp1-10;
                if(temp1>=0)
                        temp2++;
        } while(temp1>=0);
        LCD_senddata(temp2+0x30);
        temp2 = temp1+10;
        LCD_senddata(temp2+0x30);
}