
#ifndef __LCD_H__
#define __LCD_H__

typedef unsigned char bit_8;

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			LCD Port Configuration
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

__sfr __at (0x90) LCD_PORT;
__sbit __at (0xA0) rs;
__sbit __at(0xA1) rw;
__sbit __at(0xA2) en;
__sbit __at( 0x97) flag;

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	LCD Command MACROS
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#define LCD_CLEAR 0x1
#define RETURN_HOME 0x2
#define DEC_CURSOR 0x4
#define INC_CURSOR 0x6
#define DISP_OFF_CUR_OFF 0x8
#define DISP_OFF_CUR_ON 0xA
#define DISP_ON_CUR_OFF 0xC
#define DISP_ON_CUR_BLINK 0xE
#define SHIFT_CUR_LEFT 0x10
#define SHIFT_CUR_RIGHT 0x14
#define SHIFT_DISP_LEFT 0x18
#define SHIFT_DISP_RIGHT 0x1C
#define LCD_row1() LCD_command(0x80)
#define LCD_row2() LCD_command(0xC0)

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		Function Prototypes
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

void LCD_init(void);		// Initialize LCD
void busy(void);			// Check Busy
void LCD_command(bit_8);		// Sending Command
void LCD_senddata(bit_8);		// Sending single character
void LCD_sendstring(bit_8*);	// Sending String
void LCD_sendnum(bit_8);		// Sending 8-bit Decimal value
void LCD_cursorxy(bit_8,bit_8);	// Bringing Cursor to (X,Y) location X -> 1,2 and Y -> 1-16
void MSDelay(unsigned int itime);
void hex2lcd(unsigned char);
#endif